/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_itoa.c                                          :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: vibucho <marvin@42.fr>                     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/11/06 16:45:53 by vibucho           #+#    #+#             */
/*   Updated: 2014/11/06 16:50:03 by vibucho          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "libft.h"

static	int				ft_intlen(int n)
{
	int i;

	i = 1;
	while (n /= 10)
		i++;
	return (i);
}

static	void			ft_dudul(int i, int k, char *dst)
{
	while (--i >= 0)
	{
		if (k < 0)
			dst[i] = -(k % 10) + '0';
		else
			dst[i] = k % 10 + '0';
		k = k / 10;
	}
}

char					*ft_itoa(int n)
{
	char	*dst;
	int		i;
	int		k;

	if (n == -2147483648)
		return (ft_strdup("-2147483648"));
	k = n;
	i = ft_intlen(n);
	if (n < 0)
	{
		dst = malloc(sizeof(char) * (i + 2));
		*dst++ = '-';
	}
	else
		dst = malloc(sizeof(char) * (i + 1));
	dst[i] = '\0';
	ft_dudul(i, k, dst);
	if (n < 0)
		return (--dst);
	return (dst);
}
