/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_strsplit.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: vibucho <marvin@42.fr>                     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/11/06 18:26:44 by vibucho           #+#    #+#             */
/*   Updated: 2014/11/06 18:26:46 by vibucho          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "libft.h"

static char		**create_string(char **dst, char const *s, char c)
{
	unsigned int	i;
	int				j;
	size_t			len;

	i = 0;
	j = 0;
	len = 0;
	while (s[i])
	{
		while ((s[i] != c) && s[i])
		{
			len++;
			i++;
			if ((s[i] == c) || !s[i])
			{
				dst[j] = ft_strsub(s, (size_t)i - len, len);
				j++;
				len = 0;
			}
		}
		if (s[i])
			i++;
	}
	dst[j] = 0;
	return (dst);
}

char			**ft_strsplit(char const *s, char c)
{
	int			i;
	int			strl;
	char		**dst;

	i = 0;
	strl = 0;
	if (!s)
		return (NULL);
	if (s[0] != c && s[0])
		strl++;
	while (s[i])
	{
		if (s[i] == c)
		{
			if ((s[i + 1] != c) && s[i + 1])
				strl++;
		}
		i++;
	}
	if (!(dst = (char **)malloc(sizeof(char *) * (strl + 1))))
		return (NULL);
	return (create_string(dst, s, c));
}
